--
--
--
--
--

local FoodBehavior = (require 'game.behaviors.ItemBehavior'):extend('FoodBehavior', {
	bitesRemaining = 1,
	rotten = false
})

function FoodBehavior:update(dt)
	if(self.parent.mode.clicked) then
		self.parent.Hitbox.shape:moveTo(Game.mouse.x, Game.mouse.y)
	end
	
	if(self.rot == nil) then
		self.rot = 0
	end
	
	if(self.rotTimer == nil) then
		self.rotTimer = 0
	end
	
	self.rotTimer = self.rotTimer + dt
	
	if(self.rotTimer > 10) then
		self.rotTimer = 0
		self.rot = self.rot + 1
	end
	
	if(self.rot == 5) then
		if(self.rotten == false) then
			self.rotten = true
			self.parent.Sprite.imageData = Game.assets.images.slop
			self.parent.Item.type = Game.definitions.ItemType.TRASH
			Game.particles:moveTo(self.parent.x, self.parent.y)
			Game.particles:emit(50)
		end
	end
end

function FoodBehavior:onBite(boy)
	Game.sound:play(Game.assets.audio.chunch, "sfx")
	self.bitesRemaining = self.bitesRemaining - 1
	Game.particles:moveTo(self.parent.x, self.parent.y)
	Game.particles:emit(50)
	
	for key, value in pairs(self.parent.Item.stats) do
		boy.stats.emotions[key] = boy.stats.emotions[key] + value
	end
	
	if(self.bitesRemaining == 0) then
		--
		-- Get this bitch outta here.
		--
		Game.ecs.entities:remove(self.parent)
		boy:get('BoyBehavior').eating = nil
	end
	
	return self.bitesRemaining
end

return FoodBehavior