--
--
-- The behavior code for an item in-game.
--
--

local ItemBehavior = Game.ecs.behavior:extend('ItemBehavior', {
	id = 0,
	clickOffset = {
		x = 0,
		y = 0
	}
})

function ItemBehavior:wake(dt)
	table.insert(Game.state.food, self.parent)
	
	if(self.parent.Item == nil) then
		self.parent.Item = Game.ecs.component('Item')
	end
	
	self.parent.hitbox.width = self.parent.Sprite.imageData:getWidth()
	self.parent.hitbox.height = self.parent.Sprite.imageData:getHeight()
	
	self.parent.hitbox.offset.x = self.parent.hitbox.offset.x - math.floor((self.parent.Sprite.imageData:getWidth()) * (1 - self.parent.Sprite.origin.x))
	self.parent.hitbox.offset.y = self.parent.hitbox.offset.y - math.floor((self.parent.Sprite.imageData:getHeight()) * (self.parent.Sprite.origin.y))	
end

function ItemBehavior:update(dt)	
	if(self.parent.mode.clicked) then
		self.parent.Hitbox.shape:moveTo(Game.mouse.x, Game.mouse.y)
	end
end

function ItemBehavior:onRightClick(dt)
	Game.ecs.entities:remove(self.parent)
	Game.particles:moveTo(self.parent.x, self.parent.y)
	Game.particles:emit(50)
end

return ItemBehavior