--
--
--
--
--

local MenuBehavior = Game.ecs.behavior:extend('MenuBehavior')

function MenuBehavior:onHover(dt)
	love.mouse.setCursor(love.mouse.getSystemCursor('hand'))
end

function MenuBehavior:onLeave(dt)
	love.mouse.setCursor(love.mouse.getSystemCursor('arrow'))
end

function MenuBehavior:draw(dt)
	if(self.parent.mode.hovered) then
		love.graphics.setColor(255, 255, 255, 255)
		love.graphics.setLineWidth(2)
		
		love.graphics.rectangle(
			"line",
			math.ceil(self.parent.x + math.floor(self.parent.hitbox.offset.x) - 2),
			math.ceil(self.parent.y + math.floor(self.parent.hitbox.offset.y) - 2),
			math.ceil(self.parent.hitbox.width + 4),
			math.ceil(self.parent.hitbox.height + 4)
		)
	end
end

return MenuBehavior
