--
-- 
--

--
--
-- Checks to see whether the point is contained.
--
--
function contains(x, y, aX, aY, bX, bY)
	if(x > aX) and (x < bX) and (y > aY) and (y < bY) then 
		return true 
	else 
		return false
	end
end

function onCollide(dt, one, two)
	
end

function math.dist(x1,y1, x2,y2) return ((x2-x1)^2+(y2-y1)^2)^0.5 end

--
--
--
function table.merge(t1, t2)
    for k,v in pairs(t2) do
        if type(v) == "table" then
            if type(t1[k] or false) == "table" then
                table.merge(t1[k] or {}, t2[k] or {})
            else
                t1[k] = v
            end
        else
            t1[k] = v
        end
    end
    return t1
end

function table.length(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

function string.random(length)
	if(Game._charset == nil) then
		Game._charset = {}
		Game._charsetLength = 0
		
		for i = 48, 57 do
			table.insert(Game._charset, i)
			Game._charsetLength = Game._charsetLength + 1
		end
		
		for i = 65, 90 do
			table.insert(Game._charset, string.char(i))
			Game._charsetLength = Game._charsetLength + 1
		end
		
		for i = 97, 122 do
			table.insert(Game._charset, string.char(i))	
			Game._charsetLength = Game._charsetLength + 1
		end
		
		print('Charset loaded')
	end
	
	local stringReturn = ''
	
	for i = 1, length do
		local random = math.random(1, Game._charsetLength)
		stringReturn = stringReturn .. Game._charset[random]
	end

	return stringReturn
	
end

function math.round(number)
	if(number % 1) > 0.5 then 
		return math.ceil(number)
	else
		return math.floor(number)
	end
end

function math.clamp(val, lower, upper, loop)
	if(loop == nil) then
		loop = false
	end
	
    assert(val and lower and upper, "not very useful error message here")
    if lower > upper then lower, upper = upper, lower end -- swap if boundaries supplied the wrong way
	
	if(loop) then
		if(val < lower) then
			return upper
		elseif(val > upper) then
			return lower
		else
			return val
		end
	end
	
    return math.max(lower, math.min(upper, val))
end

--
-- Gets the angle between two points.
--
function math.angle(x1,y1, x2,y2) 
	return math.atan2(y2-y1, x2-x1) 
end

--
-- Lerp.
--
function math.lerp(a, b, t) 
	return a + (b - a) * t 
end

--
--
--
function math.rsign(num)
	if(num >= 0) then
		return 1
	else
		return -1
	end
end

function popOff(message, x, y, dir)
	dir = dir or false
	
	local textEntity = Game.ecs.entity:extend('TextNote'):new()
	textEntity.Text = Game.ecs.component('Text')
	textEntity.Text.text = message
	textEntity.Text.layer = 'foreground'
	textEntity.age = 0
	textEntity.xAge = math.random(3, 7)
	
	if(dir) then
		textEntity.xAge = -textEntity.xAge
	end
	
	textEntity.update = function(self, dt)
		self.class.update(self)
		self.age = self.age + 1
		self.x = self.x + self.xAge
		self.y = self.y - ((500 * dt) - (self.age))
		
		if(self.y < 0 or self.y > 600) then
			Game.worlds.scenes.play:remove(self)
		end
	end
	
	textEntity.y = y
	textEntity.x = x
	Game.worlds.scenes[Game.worlds.activeScene]:addEntity(textEntity)	
end