--
--
--

local MenuWorld = Game.ecs.world:extend('MenuWorld')

local MenuSystem = Game.ecs.system:extend('MenuSystem')

function MenuSystem:startDraw(dt)
	love.graphics.print('Oh! My Boy! is a clicker/pet game made for 1-bit Clicker Jam.', 20, 50)
	
	love.graphics.print('a team slime game.', 50, 150)
end

local returnButton = Game.ecs.entity:new()
returnButton:add('MenuBehavior')
returnButton:get('MenuBehavior').onLeftClick = function(self, dt)
	Game.worlds:setScene('menu')
end

returnButton.Text = Game.ecs.component('Text')
returnButton.Text.text = 'return to menu'

returnButton.x = 50
returnButton.y = 500

returnButton.hitbox.width = Game.fonts.game:getWidth(Game.strings.Menu.Return)
returnButton.hitbox.height = Game.fonts.game:getHeight(Game.strings.Menu.Return)

MenuWorld:addEntity(returnButton)
MenuWorld:addSystem(MenuSystem:new())
MenuWorld:addSystem(require 'game.systems.TextRender':new())

return MenuWorld