--
--
--
--
--

local SpriteRenderSystem = Game.ecs.system:extend('SpriteRenderSystem', {
	spritesRendered = 0
})

function SpriteRenderSystem:filter(entity)
	return not (entity.Sprite == nil)
end

function SpriteRenderSystem:draw(entity, dt)	
	love.graphics.setCanvas(Game.layers[entity.Sprite.layer])
	
	if(entity.Sprite.clip.active) then
		love.graphics.drawq(
			entity.Sprite.imageData, 
			love.graphics.newQuad(
				entity.Sprite.clip.x, 
				entity.Sprite.clip.y, 
				entity.Sprite.clip.width, 
				entity.Sprite.clip.height, 
				entity.Sprite.imageData:getWidth(), 
				entity.Sprite.imageData:getHeight()
			),
			entity.x + entity.Sprite.offset.x, 
			entity.y + entity.Sprite.offset.y
		)
	else 
		love.graphics.draw(
			entity.Sprite.imageData, 
			math.round(entity.x + entity.Sprite.offset.x), 
			math.round(entity.y + entity.Sprite.offset.y), 
			entity.Sprite.rotation, 
			entity.Sprite.scale, entity.Sprite.scale, 
			math.floor(entity.Sprite.imageData:getWidth() * entity.Sprite.origin.x), 
			math.floor(entity.Sprite.imageData:getHeight() * entity.Sprite.origin.y)
		)
	end
end

return SpriteRenderSystem