--
--
-- Text rendering system.
--
--

local TextRender = Game.ecs.system:extend('TextRender')

function TextRender:filter(entity)
	if(entity.Text == nil) then
		return false
	else
		return true
	end
end

function TextRender:draw(entity, dt)
	love.graphics.setCanvas(Game.layers[entity.Text.layer])
	
	if(entity.Text.font) then
		love.graphics.setFont(entity.Text.font, entity.Text.size)
	else
		love.graphics.setFont(Game.fonts.game, entity.Text.size * 16)
	end
	
	if(entity.Text.color) then
		love.graphics.setColor(entity.Text.color.r, entity.Text.color.g, entity.Text.color.b)
	else
		love.graphics.setColor(255, 255, 255)
	end
	
	if(entity.Text.prettyPrint) then
		love.graphics.printf(entity.Text.text, entity.x + entity.Text.offset.x, entity.y + entity.Text.offset.y, entity.Text.wrap, entity.Text.align)
	else
		love.graphics.print(entity.Text.text, entity.x + entity.Text.offset.x, entity.y + entity.Text.offset.y)
	end

	love.graphics.setCanvas()
end

return TextRender